# we use the upstream version from http_parser.h as the SONAME
%define somajor 2
%define sominor 0

%define libname %mklibname %{name} %{somajor}
%define devname %mklibname -d %{name}

Name:           http-parser
Version:        2.9.2
Release:        %mkrel 1
Summary:        HTTP request/response parser for C
Group:          System/Libraries
License:        MIT
URL:            http://github.com/joyent/http-parser
Source0:	https://github.com/joyent/http-parser/archive/v%{version}/%{name}-%{version}.tar.gz
# Build shared library with SONAME using gyp and remove -O flags so optflags take over
# TODO: do this nicely upstream
Patch1:		http-parser-gyp-sharedlib.patch
BuildRequires:	gyp

%description
This is a parser for HTTP messages written in C. It parses both requests and
responses. The parser is designed to be used in performance HTTP applications.
It does not make any syscalls nor allocations, it does not buffer data, it can
be interrupted at anytime. Depending on your architecture, it only requires
about 40 bytes of data per message stream (in a web server that is per
connection).

%package -n %{libname}
Summary:	A parser for HTTP messages written in C
Group:		System/Libraries

%description -n %{libname}
This is a parser for HTTP messages written in C. It parses both requests and
responses. The parser is designed to be used in performance HTTP applications.
It does not make any syscalls nor allocations, it does not buffer data, it can
be interrupted at anytime. Depending on your architecture, it only requires
about 40 bytes of data per message stream (in a web server that is per
connection).

%package -n %{devname}
Group:		Development/C
Summary:	Development headers and libraries for http-parser
Requires:	%{libname} = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}

%description -n %{devname}
Development headers and libraries for http-parser.

%prep
%setup -q
%autopatch -p0

%build
# TODO: fix -fPIC upstream
export CFLAGS='%{optflags} -fPIC'
gyp -f make --depth=`pwd` http_parser.gyp
%make BUILDTYPE=Release

%install
install -d %{buildroot}%{_includedir}
install -d %{buildroot}%{_libdir}

install -pm644 http_parser.h %{buildroot}%{_includedir}

#install regular variant
install out/Release/lib.target/libhttp_parser.so.%{somajor} %{buildroot}%{_libdir}/libhttp_parser.so.%{somajor}.%{sominor}
ln -sf libhttp_parser.so.%{somajor}.%{sominor} %{buildroot}%{_libdir}/libhttp_parser.so.%{somajor}
ln -sf libhttp_parser.so.%{somajor}.%{sominor} %{buildroot}%{_libdir}/libhttp_parser.so

#install strict variant
install out/Release/lib.target/libhttp_parser_strict.so.%{somajor} %{buildroot}%{_libdir}/libhttp_parser_strict.so.%{somajor}.%{sominor}
ln -sf libhttp_parser_strict.so.%{somajor}.%{sominor} %{buildroot}%{_libdir}/libhttp_parser_strict.so.%{somajor}
ln -sf libhttp_parser_strict.so.%{somajor}.%{sominor} %{buildroot}%{_libdir}/libhttp_parser_strict.so

%check
export LD_LIBRARY_PATH='./out/Release/lib.target'
./out/Release/test-nonstrict
./out/Release/test-strict

%files -n %{libname}
%doc AUTHORS 
%{_libdir}/libhttp_parser.so.%{somajor}
%{_libdir}/libhttp_parser.so.%{somajor}.*
%{_libdir}/libhttp_parser_strict.so.%{somajor}
%{_libdir}/libhttp_parser_strict.so.%{somajor}.*

%files -n %{devname}
%{_includedir}/*
%{_libdir}/libhttp_parser.so
%{_libdir}/libhttp_parser_strict.so


%changelog
* Mon Apr 22 2019 kekepower <kekepower> 2.9.2-1.mga6
+ Revision: 1394649
- Update to version 2.9.2 (mga#21330)
+ neoclust <neoclust>
- New version 2.7.1

* Thu Feb 04 2016 umeabot <umeabot> 2.2.1-4.mga6
+ Revision: 935938
- Mageia 6 Mass Rebuild

* Wed Oct 15 2014 umeabot <umeabot> 2.2.1-3.mga5
+ Revision: 747552
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 2.2.1-2.mga5
+ Revision: 680193
- Mageia 5 Mass Rebuild

* Tue Feb 04 2014 wally <wally> 2.2.1-1.mga5
+ Revision: 582060
- new version 2.2.1
- clean .spec a bit

* Fri Jan 10 2014 tv <tv> 2.0-1.20121128gitcd01361.mga4
+ Revision: 566124
- imported package http-parser

